/* Un outil pour produire des formules bien formes  hasard */
/* A utiliser pour tester votre projet */
/* Problme : comme amliorer le code ? */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <unistd.h>


/* crire ici votre syntaxe prfre */

#define CONJ_CHAINE "&"
#define DISJ_CHAINE "|"
#define NEG_CHAINE "!"
#define IMPL_CHAINE "->"

/* Profondeur Maximum */
#define  MAX_DEPTH 20

/* Les variables propositionnelles */
char *variable[] = {"a","b","c","d","e"};

typedef struct operation
{
  char *symbole;
  int arite;
}Operation;

Operation operation[] = {
  { DISJ_CHAINE, 2 },
  { CONJ_CHAINE, 2},
  { NEG_CHAINE, 1},
  { IMPL_CHAINE, 2},
  /* Ajouter la ligne suivante ... si l'on veut */
  /*  {"<->",2}, */
  {"var",0}
};

#define NOVARS ((sizeof variable)/sizeof(char *))
#define NOOPS ((sizeof operation)/sizeof(Operation))


char *chaine_engendrer(int depth);
void usage (char *command);

/* Voici le programme ... enfin */

int main(int argc, char *argv[])
{
  
  char *chaine;
  int max_depth=MAX_DEPTH;

  int verbose=0;

  {
    char c;
    extern int optind;
    int noargs;

    while((c=getopt(argc,argv,"v")) != -1)
      if( c == 'v')
	verbose=1;
     
    noargs = argc -optind;

    if( ( noargs> 1) || 
	((noargs ==  1) && 
	 (sscanf(argv[optind],"%d",&max_depth) == 0)) ) 
      usage(argv[0]);

  }

  max_depth = (max_depth <= MAX_DEPTH)?max_depth:MAX_DEPTH;
  
  srand( time(NULL) * getpid());

  chaine = chaine_engendrer(max_depth);

  printf("%s\n",chaine);
  
  if(verbose)
    printf("\nLonguer de la chaine : %d\n", strlen(chaine));


  free(chaine);
  
  exit(EXIT_SUCCESS);


}

char *chaine_engendrer(int depth)
{

  char *ret,*chaine_agauche,*chaine_adroite;
  int i,j;

  if(depth == 0)
    {
      j  = rand() % NOVARS;
      ret = malloc(strlen(variable[j]) + 1);
      strcpy(ret,variable[j]);
    }
  else
    {
      i = rand() % NOOPS;
      switch(operation[i].arite)
	{
	case 0:
	  j  = rand() % NOVARS;
	  ret = malloc(strlen(variable[j]) + 1);
	  strcpy(ret,variable[j]);
	  break;
	case 1:
	  chaine_agauche = chaine_engendrer(depth -1);
	  ret = malloc(strlen(chaine_agauche)  
		       + strlen(operation[i].symbole) + 2 + 1);
	  strcpy(ret,operation[i].symbole);
	  /* Pour une opration unaire on ne veut pas de parenthses */
	  /* strcat(ret,"("); */
	  strcat(ret,chaine_agauche);
	  /* strcat(ret,")"); */
	  free(chaine_agauche);
	  break;
	case 2:
	  chaine_agauche = chaine_engendrer(depth -1);
	  chaine_adroite = chaine_engendrer(depth -1);
	  ret = malloc( strlen(chaine_agauche) 
			+ strlen(chaine_adroite) 
			+ strlen(operation[i].symbole) + 2 + 1);
	  strcpy(ret,"(");
	  strcat(ret,chaine_agauche);
	  strcat(ret,operation[i].symbole);
	  strcat(ret,chaine_adroite);
	  strcat(ret,")");
	  free(chaine_agauche);
      	  free(chaine_adroite);
	  break;
	default:
	  ;
	}
      
    }
  
  return ret;
}


void usage (char *command)
{
  printf(
	 "Usage : %s [-v] [profondeur-maximum]\n"
	 "Exemple :\n"
	 "> %s 4\n"
	 "produit une formule de profondeur maximum 4.\n", 
	 command,command);

  exit(EXIT_FAILURE);
}
