%macro plotcrosscorr(corr,X,Y);
/* PLOT de la correlation croisee */

SYMBOL1 I=join CI=green value=circle;
title "Correlation croisee du processus (&X,&Y)";

DATA crosscorrXX (KEEP= rho11 h);
SET &corr;
if MOD(_N_,2) = 1 ;
rho11 = &X;
h = LAG;
RUN;

DATA crosscorrYY (KEEP= rho22 h);
SET &corr;
if MOD(_N_,2) = 0 ;
rho22 = &Y;	
h = LAG;
RUN;

DATA crosscorrXY (KEEP= rho12 h);
SET &corr;
if MOD(_N_,2) = 1 then do;
	rho12 = &Y;	
	h = -LAG;
end;
else do;
	rho12 = &X;
	h = LAG;
end;
RUN;

DATA crosscorr;
set crosscorrxx crosscorryy crosscorrxy ;
RUN;

PROC SORT data=crosscorr; 
BY h;
RUN;
QUIT;

PROC GPLOT data=crosscorr;
title2 "rho11(h), rho22(h), rho12(h)";
PLOT rho11*h ;
PLOT rho22*h ;
PLOT rho12*h ;
RUN;
QUIT;

title " ";
symbol1;

%mend plotcrosscorr;


FILENAME ls2 "C:\Documents and Settings\lsantoca\Mes documents\My SAS Files\V8\ls2.dat";

/* Options pour la presentation des lignes */

SYMBOL1 I=join CI=green;
SYMBOL2 I=join CI=red;
SYMBOL3 I=join CI=blue;


/* Lire la serie ls2, engendrer la serie differentielle */

DATA ls2;
INFILE ls2;
INPUT X Y;
T=_N_;
DIFX = DIF(X);
DIFY = DIF(Y);
RUN;

PROC GPLOT DATA=ls2;
PLOT X*T Y*T/overlay;
PLOT DIFX*T DIFY*T/overlay;
RUN;
QUIT;

/* PROCEDURE VARMAX : VAR(1) */
ods OUTPUT CORRYlags=corr; 
PROC VARMAX DATA=ls2; /*DIFY=(1 1);*/
MODEL DIFX DIFY / P=1 CENTER PRINT=(CORRY) LAGMAX=20;
RUN;
QUIT;
ODS OUTPUT CLOSE; 
/* PLOT de la correlation croisee */
%plotcrosscorr(corr,DIFX,DIFY)


proc arima data=ls2;
identify var=difx;
estimate  q=1;
forecast back=0 out=residu;
run;
quit;


proc arima data=ls2;
identify var=dify;
estimate  q=1;
forecast back=0 out=residu2;
run;
quit;


data res1 (keep= r1);
set residu;
r1= residual;
run;
quit;

data res2 (keep= r2);
set residu2;
r2=residual;
run;
quit;

data res;
merge res1 res2;
T = _N_;
run;
quit;

ods OUTPUT CORRYlags=corr; 
PROC VARMAX DATA=res;
MODEL r1 r2 / P=1 CENTER PRINT=(CORRY) LAGMAX=20;
RUN;
QUIT;
ODS OUTPUT CLOSE; 


PROC GPLOT DATA=res;
PLOT r1*T r2*T/overlay;
RUN;
QUIT;

/* PLOT de la correlation croisee */
%plotcrosscorr(corr,r1,r2)
