/* Coefficient d'aversion au risque */
%let A=0.0001;
/* Montant disponible (10000 euros) */
%let w=10000; 
/* Premier actif */
%let actif1=aventis; 
/* Deuxieme actif */
%let actif2=socgen; 
/* Taux */
%let taux=0.0128;
/* Sur combien de jours */
%let jours=30;

/* Dernier Jour */
%let dernierjour='29NOV2002'd;

%let CHEMIN=C:\Documents and Settings\lsantoca\Mes documents\My SAS Files\V8\;

/* Lire les donnees */
%macro lireactif(actif,tauxj);
    %global dernier&actif;
     
    %let FICHIER=&actif..tab;
    FILENAME &actif "&CHEMIN&FICHIER";
    
    DATA &actif (keep=DATE prix ypetit Ygrand  
		     rename=(prix = prix&actif 
				 ypetit = ypetit&actif 
				 Ygrand=Ygrand&actif) );
	INFILE &actif DSD dlm='09'x truncover firstobs=2;
	INPUT DATE:ddmmyy10. NOM$ SICOVAM PREMIER; 
	FORMAT DATE date6.;
	jtaux=&tauxj;
	prix=PREMIER;
	lag=LAG(prix);
	dif=DIF(prix);
	ypetit=dif/lag;
	Ygrand=prix - (1 + LAG(jtaux))*LAG(prix);
    RUN;

    DATA _null_;
	set &actif;
	if(DATE = &dernierjour);
	call symput("dernier"||"&actif",prix&actif);
    RUN;

    
    %mend lireactif;





