#ifndef FORMULESETMODELES_H
#define FORMULESETMODELES_H

#include "syntaxe.h"

typedef enum {CONJ,DISJ,NEG,VAR,IMPL} Operation;
typedef int Variable;

#define NOVARS (LASTVAR-FIRSTVAR+1)

typedef struct formule{
  Operation op;
  Variable var;
  struct formule *filsagauche;
  struct formule *filsadroite;
} Formule;

typedef struct modele{
  int val[NOVARS];  
} Modele;

extern
void imprimer_formule(Formule *formule);

extern
int est_satisfaite(Formule *formule,Modele *modele);

/*
  Construction des variables 
   partir des chanes de caractres
*/

extern
Variable strtovar(char *chaine);

/* Construction et destruction des formules */
extern
Formule *conjonctionde(Formule *f1,Formule *f2);
extern
Formule *disjonctionde(Formule *f1,Formule *f2);
extern
Formule *implicationde(Formule *f1,Formule *f2);
extern
Formule *negationde(Formule *f);
extern
Formule *variablede(Variable v);

extern
void libererformule(Formule *f);


/* Construction et destruction des modles */

extern
void liberermodele(Modele *m);

#endif /* FORMULESETMODELES_H */
