%{
#include <stdio.h>
#include <stdlib.h>


#include "grammaire.h"
#include "getons.h"
  

 
static void yyerror(const char *str);


  void yyerror(const char *str)
    {
      fprintf(stderr,"Erreur d'analyse syntaxique : %s\n",str);
      exit(EXIT_FAILURE);
    }
  
  
  int yywrap()
    {
      return 1;
    } 
  
%}


%start RACINE

%token OUVERTE
%token FERMEE
%token VARIABLE
%nonassoc CONJONCTION DISJONCTION IMPLICATION
%nonassoc NEGATION

%%

RACINE:
formule
{
  $$ = $1;
  yylval =$$; 
}

formule:
VARIABLE { $$ = variablede(strtovar(yytext)); }
|
NEGATION formule { $$ = negationde($2); }
|
OUVERTE formule FERMEE { $$ = $2; }
|
formule CONJONCTION formule { $$ = conjonctionde($1,$3); }
|
formule DISJONCTION formule { $$ = disjonctionde($1,$3); }
|
formule IMPLICATION formule { $$ = implicationde($1,$3); }
