/* Luigi Santocanale : saisie.c */
/* Last modified : Sat Nov 29 09:12:49 CET 2003      */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <limits.h> /* Pour trouver PIPE_BUF */ 

#include "formulesetmodeles.h"
#include "saisie.h"
#include "grammaire.h" 

#define SIERR_PEXIT(command) \
{\
if ((command) == -1) \
{\
perror("saisie.c"); \
exit(EXIT_FAILURE); \
}\
}\

#define DIMTAMPON PIPE_BUF

extern Formule * yylval; 

Formule *saisie_formule(char *string)
{

  char tampon[DIMTAMPON];
  Formule *f;
  int code_retour;
  int stdin_save; 

  if(string == NULL)
    {
      printf("Rentrez une formule (max %d chars) :\n\t",DIMTAMPON -1);
      fflush(stdout);
      fgets(tampon,DIMTAMPON,stdin);
    }
  else
    {
      if(strlen(string) < DIMTAMPON)
	strncpy(tampon,string,DIMTAMPON);
      else
	{
	  printf("Formule trop longue.\n");
	  exit(EXIT_FAILURE);
	}
    }

    {
  
      int tube[2];
  
      SIERR_PEXIT( stdin_save = dup(STDIN_FILENO) );
      SIERR_PEXIT( pipe(tube) );
      SIERR_PEXIT( dup2(tube[0],STDIN_FILENO) );
      SIERR_PEXIT( close(tube[0]) );
      SIERR_PEXIT( write(tube[1],tampon,strlen(tampon)) );
      SIERR_PEXIT( close(tube[1]) );


      code_retour = yyparse();
      f = yylval;

      SIERR_PEXIT( dup2(stdin_save,STDIN_FILENO) );
      SIERR_PEXIT( close(stdin_save) );
    }
  


  if(code_retour == 1 || f == NULL)
    {
      printf("Rien a t reconnu.\n");
      exit(EXIT_FAILURE);
    }
  
  printf("Je teste la formule :\n\t%s\n",tampon);
  fflush(stdout);
  
 
  return f; 
}



Modele *saisie_modele()
{
  Modele *mod=malloc(sizeof(Modele));
  int i;
  char c; 

 
  printf("Rentrez le modle :\n");

  for(i=0;i<NOVARS;i++)
    {
      printf("\t%c |-> ", FIRSTVAR+i);
      fflush(stdout);
	
      while(1){
	
	/* se liberer de toutes les nouvelles lignes ... */
	do
	  {

	    c = getchar(); 
	  }
	while(c == '\n');
	
	if(c == '0' || c == '1')
	  { 
	    mod->val[i] = c - '0';
	    break;
	  }
      }
    }


  return mod;
}




