/* Ce programme prende en entr une formule et un modle */
/* Retourne si la   oui  */
/* si la formula est satisfaite dans le modle,  */
/*   non si non */

/* Luigi Santocanale : main.c */
/* Last modified : Mon Nov 24 09:55:17 CET 2003      */


#include <stdio.h> 
#include <stdlib.h> 
#include <unistd.h>

#include "formulesetmodeles.h"
#include "saisie.h"

#define DIM_CHAINE 76

void usage (char *command);

int
main(int argc, char *argv[]){

  Formule *formule;
  Modele  *modele;
  int val;

  {
    /* On voit si on a besoin d'aide */
    char c;
    extern int optind;
    int noargs;

    while((c=getopt(argc,argv,"h")) != -1)
      if( c == 'h') 
	usage(argv[0]);
     
    noargs = argc -optind;

    if( ( noargs> 1))
      usage(argv[0]);

  }


  if(argc == 2)
    {
      formule = saisie_formule(argv[1]);
    }
  else
    {
      formule = saisie_formule(NULL);
    }

  modele = saisie_modele();

  if(formule == NULL || modele == NULL)
    exit(EXIT_FAILURE);

  val = est_satisfaite(formule,modele);
  
  printf("La formule\n\t");
  imprimer_formule(formule);
  printf("\n");
  if(val == 1)
    printf("est satisfaite par ce modle :-)\n");
  else
    printf("n'est pas satisfaite par ce modle :-(\n");

  libererformule(formule);
  liberermodele(modele);

  exit(EXIT_SUCCESS);
}


void usage (char *command)
{
  printf(
	 "Usage : %s [-h] [formule]\n"
	 "Exemple :\n"
	 "> %s \"a&b\"\n"
	 "Demande un modle\n" 
	 "et vrifie si la formule a&b"
	 " est satisfaite par le modle.\n"
	 "> %s\n"
	 "Demande une formule et un modle\n"
	 "et vrifie si la formule"
	 " est satisfaite par le modle.\n"
	 , 
	 command,command,command);

  exit(EXIT_FAILURE);
}
